<ui:composition xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns="http://www.w3.org/1999/xhtml"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:c="http://java.sun.com/jstl/core"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:gri="http://java.sun.com/jsf/composite/gri"
                xmlns:rich="http://richfaces.org/rich">
    <!--  requires param
          - patient (net.ihe.gazelle.simulator.pam.model.Patient)
          - renderHistory (boolean) : indicates whether or not the Patient History tab containing the patient relations is shown
          - renderZFD (boolean)
          - zfp (boolean)
          - managedBean
          - renderRelationships
          - managePids-->
    <ul class="nav nav-tabs" role="tablist">
        <li role="presentation" class="active">
            <a href="#demo" aria-controls="demo" role="tab" data-toggle="tab">#{messages['gazelle.simulator.pam.DemographicInformations']}</a>
        </li>
        <li role="presentation">
            <a href="#addr" aria-controls="addr" role="tab" data-toggle="tab">#{messages['gazelle.pam.LocationInformation']}</a>
        </li>
        <li role="presentation">
            <a href="#pid" aria-controls="pid" role="tab" data-toggle="tab">#{messages['net.ihe.gazelle.PatientManager.PatientIdentifiers']}</a>
        </li>
        <li role="presentation">
            <a href="#extra" aria-controls="extra" role="tab"
               data-toggle="tab">#{messages['gazelle.pam.AdditionalInformations']}</a>
        </li>
        <c:if test="${renderRelationships}">
            <li role="presentation">
                <a href="#relationships" aria-controls="relationships" role="tab"
                   data-toggle="tab">#{messages['net.ihe.gazelle.patientmanager.Relationships']}</a>
            </li>
        </c:if>
        <c:if test="${renderZFD}">
            <li role="presentation">
                <a href="#legalCareModes" aria-controls="legalCareModes" role="tab"
                   data-toggle="tab">#{messages['gazelle.PAMSimulator.LegalCareModes']}</a>
            </li>
        </c:if>
        <c:if test="${renderHistory}">
            <li role="presentation">
                <a href="#history" aria-controls="history" role="tab"
                   data-toggle="tab">#{messages['gazelle.pam.History']}</a>
            </li>
        </c:if>
    </ul>
    <div class="tab-content tab-content-with-border">
        <div role="tabpanel" class="tab-pane active" id="demo">
            <s:div rendered="#{!iti30Manager.isBp6Mode()}">
                <ui:include src="/patient/editAbstractPatientDemographic.xhtml">
                    <ui:param name="patient" value="#{patient}"/>
                    <ui:param name="displayFullDemographics" value="#{true}"/>
                    <ui:param name="codeProvider" value="#{pamDemographicCodeProvider}"/>
                    <ui:param name="renderMothersMaidenName" value="#{not simulatorFeatureDAO.isEPDEnabled()}"/>
                </ui:include>
            </s:div>
            <s:div rendered="#{iti30Manager.isBp6Mode()}">
                <ui:include src="/patient/editAbstractPatientDemographicBP6.xhtml">
                    <ui:param name="patient" value="#{patient}"/>
                    <ui:param name="displayFullDemographics" value="#{true}"/>
                    <ui:param name="codeProvider" value="#{pamDemographicCodeProvider}"/>
                    <ui:param name="renderMothersMaidenName" value="#{not simulatorFeatureDAO.isEPDEnabled()}"/>
                </ui:include>
            </s:div>
        <ui:include src="/patient/editPatientExtraDemographics.xhtml"/>
    </div>
    <div role="tabpanel" class="tab-pane" id="addr">
        <ui:include src="/patient/editAbstractPatientAddress.xhtml">
            <ui:param name="patient" value="#{patient}"/>
            <ui:param name="managerBean" value="#{managedBean}"/>
            <ui:param name="advancedEdit" value="#{true}"/>
            <ui:param name="codeProvider" value="#{pamDemographicCodeProvider}"/>
        </ui:include>
    </div>
    <div role="tabpanel" class="tab-pane" id="pid">
        <s:div id="pidList">
            <h:outputText
                    value="#{messages['gazelle.simulator.pam.YouCanEditremoveExistingIdentifiersAndorAddNewOnes']}"
                    styleClass="help-block"/>
            <a4j:repeat value="#{managedBean.patientIdentifiers}"
                        var="pid">
                <div class="row">
                    <rich:inplaceInput id="idEdit" minInputWidth="300px" editClass="form-control"
                                       defaultLabel="#{messages['gazelle.simulator.pam.ClickToUpdatePatientIdentifier']}"
                                       value="#{pid.object2}" showControls="true" inputWidth="600">
                        <a4j:ajax event="change"
                                  listener="#{managedBean.changeIdentifier(pid.object1, pid.object2)}"
                                  render="pidList"/>
                    </rich:inplaceInput>
                    <a4j:commandLink actionListener="#{managedBean.removeIdentifier(pid.object1)}"
                                     render="pidList"
                                     title="#{messages['net.ihe.gazelle.patientmanager.RemoveIdentifier']}"
                                     execute="@this">
                        <s:span styleClass="gzl-icon-trash-o "/>
                    </a4j:commandLink>
                </div>
            </a4j:repeat>
            <div class="form-inline">
                <s:decorate template="/layout/form/_edit.xhtml">
                    <ui:define name="label">#{messages['gazelle.pam.NewPatientIdentifier']}</ui:define>
                    <ui:param name="id" value="newIdInput"/>
                    <span class="input-group">
                        <h:inputText value="#{managedBean.newPatientIdentifier}" styleClass="form-control"
                                     id="newIdInput" size="180"/>
                            <span class="input-group-btn">
                        <a4j:commandButton actionListener="#{managedBean.addIdentifier()}"
                                           render="pidList" value="#{messages['net.ihe.gazelle.patientmanager.Add']}"
                                           styleClass="gzl-btn-green"/>
                                </span>
                        </span>
                </s:decorate>
            </div>
        </s:div>
    </div>
    <div role="tabpanel" class="tab-pane" id="extra">
        <ui:include src="/patient/editPatientExtraInfo.xhtml">
            <ui:param name="patient" value="#{patient}"/>
            <ui:param name="managedBean" value="#{managedBean}"/>
        </ui:include>
        <f:subview id="exForFr" rendered="#{renderZFD}">
            <ui:include src="/fr/_editAdditionalDemograhics.xhtml">
                <ui:param name="demographics" value="#{patient.additionalDemographics}"/>
                <ui:param name="zfp" value="#{zfp}"/>
            </ui:include>
        </f:subview>
    </div>
    <c:if test="${renderRelationships}">
        <div role="tabpanel" class="tab-pane" id="relationships">
            <a4j:commandButton value="#{messages['net.ihe.gazelle.patientmanager.AddARelationship']}"
                               render="relationDetails"
                               actionListener="#{managedBean.createNewRelationship()}"
                               rendered="#{managedBean.currentRelationship == null}"
                               styleClass="gzl-btn-green"/>
            <s:div id="relationDetails">
                <gri:panel rendered="#{managedBean.currentRelationship != null}">
                    <f:facet name="header">#{messages['net.ihe.gazelle.patientmanager.NewRelationship']}</f:facet>
                    <ui:include src="/patient/editPerson.xhtml">
                        <ui:param name="currentPerson" value="#{managedBean.currentRelationship}"/>
                    </ui:include>
                    <f:facet name="footer">
                        <a4j:commandButton value="#{messages['gazelle.HL7Common.Back']}"
                                           actionListener="#{managedBean.setCurrentRelationship(null)}"
                                           render="relationDetails"
                                           styleClass="gzl-btn-orange"/>
                        <a4j:commandButton value="#{messages['net.ihe.gazelle.patientmanager.AddRelation']}"
                                           actionListener="#{managedBean.saveRelationship()}"
                                           render="relationDetails"
                                           styleClass="gzl-btn-green"/>
                    </f:facet>
                </gri:panel>
                <!-- do not display the list when we are editing a relationship -->
                <s:div rendered="#{managedBean.currentRelationship == null}">
                    <a4j:repeat value="#{patient.personalRelationships}" var="currentPerson">
                        <f:subview id="rel#{currentPerson.id}">
                            <ui:include src="/patient/showPerson.xhtml">
                                <ui:param name="currentPerson" value="#{currentPerson}"/>
                            </ui:include>
                        </f:subview>
                    </a4j:repeat>
                </s:div>
            </s:div>
        </div>
    </c:if>
    <c:if test="${renderZFD}">
        <div role="tabpanel" class="tab-pane" id="legalCareModes">
            <ui:include src="/fr/_manageLegalCareModes.xhtml">
                <ui:param name="managedBean" value="#{managedBean}"/>
            </ui:include>
        </div>
    </c:if>
    <c:if test="${renderHistory}">
        <div role="tabpanel" class="tab-pane" id="history">
            <!-- This section will contain the list of relations of the current patient -->
            <ui:include src="historic.xhtml">
                <ui:param name="patient" value="#{patient}"/>
            </ui:include>
        </div>
    </c:if>
    </div>
</ui:composition>
